/************************************************************************
	main.h

	Main functions
    SmallyMouse - BBC Micro AMX/RB2 Mouse Emulator
    Copyright (C) 2016 Simon Inns

	This file is part of SmallyMouse.

    SmallyMouse is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

	Email: simon.inns@gmail.com

************************************************************************/

#ifndef _MAIN_H_
#define _MAIN_H_

// Hardware map

// BBC Micro/Master user-port
#define USERPORT_PB7_PORT	PORTC
#define USERPORT_PB7_PIN	PINC
#define USERPORT_PB7_DDR	DDRC
#define USERPORT_PB7		(1 << 0)

#define USERPORT_PB6_PORT	PORTC
#define USERPORT_PB6_PIN	PINC
#define USERPORT_PB6_DDR	DDRC
#define USERPORT_PB6		(1 << 1)

#define USERPORT_PB5_PORT	PORTC
#define USERPORT_PB5_PIN	PINC
#define USERPORT_PB5_DDR	DDRC
#define USERPORT_PB5		(1 << 2)

#define USERPORT_PB4_PORT	PORTC
#define USERPORT_PB4_PIN	PINC
#define USERPORT_PB4_DDR	DDRC
#define USERPORT_PB4		(1 << 3)

#define USERPORT_PB3_PORT	PORTC
#define USERPORT_PB3_PIN	PINC
#define USERPORT_PB3_DDR	DDRC
#define USERPORT_PB3		(1 << 4)

#define USERPORT_PB2_PORT	PORTC
#define USERPORT_PB2_PIN	PINC
#define USERPORT_PB2_DDR	DDRC
#define USERPORT_PB2		(1 << 5)

#define USERPORT_PB1_PORT	PORTC
#define USERPORT_PB1_PIN	PINC
#define USERPORT_PB1_DDR	DDRC
#define USERPORT_PB1		(1 << 6)

#define USERPORT_PB0_PORT	PORTC
#define USERPORT_PB0_PIN	PINC
#define USERPORT_PB0_DDR	DDRC
#define USERPORT_PB0		(1 << 7)

#define USERPORT_CB1_PORT	PORTA
#define USERPORT_CB1_PIN	PINA
#define USERPORT_CB1_DDR	DDRA
#define USERPORT_CB1		(1 << 6)

#define USERPORT_CB2_PORT	PORTA
#define USERPORT_CB2_PIN	PINA
#define USERPORT_CB2_DDR	DDRA
#define USERPORT_CB2		(1 << 7)

// Additional hardware
#define SWITCH_1_PORT		PORTB
#define SWITCH_1_PIN		PINB
#define SWITCH_1_DDR		DDRB
#define SWITCH_1			(1 << 6)

// Function prototypes
void initialiseHardware(void);
void emulationModeSwitch(void);
void processMouse(void);

// USB callback event handlers (LUFA)
void EVENT_USB_Host_HostError(const uint8_t ErrorCode);
void EVENT_USB_Host_DeviceAttached(void);
void EVENT_USB_Host_DeviceUnattached(void);
void EVENT_USB_Host_DeviceEnumerationFailed(const uint8_t ErrorCode, const uint8_t SubErrorCode);
void EVENT_USB_Host_DeviceEnumerationComplete(void);

void ReadNextReport(void);

#endif

